#!/bin/bash

SIF=eth0
LINKCEIL=1800kbit
TCPRG=tc
# Is this router on the internet side (src) or on the
# remote side (dst) ?
DIRECTION=dst
# Put the opposite of DIRECTION (src/dst) here
OTHERDIRECTION=src

# Throttle the linkt to 1800 kbit (2 MBIT line), this
# reduces queuing inside the modem and therefore latency.
# Experiment with optimal setting.


# Delete any previous settings
$TCPRG qdisc del dev $SIF root

# Get the status with: tc -s -d class show dev eth0

$TCPRG qdisc add dev $SIF root handle 1: htb default 12
$TCPRG class add dev $SIF parent 1: classid 1:1 htb rate $LINKCEIL ceil $LINKCEIL prio 1
$TCPRG class add dev $SIF parent 1:1 classid 1:10 htb rate 200kbit ceil $LINKCEIL prio 1
# ^^^ Management-Server (10.100.0.0/16) and DNS-Cache (10.0.0.1) in the network
$TCPRG class add dev $SIF parent 1:1 classid 1:11 htb rate 650kbit ceil $LINKCEIL prio 1
# ^^^ Reduce traffic to 650 kbit
$TCPRG class add dev $SIF parent 1:1 classid 1:12 htb rate 950kbit ceil $LINKCEIL prio 1
# ^^^ All traffic to the outside
$TCPRG class add dev $SIF parent 1:11 classid 1:110 htb rate 100kbit ceil $LINKCEIL prio 1
# ^^^ SSH inside the intranet
$TCPRG class add dev $SIF parent 1:11 classid 1:111 htb rate 300kbit ceil $LINKCEIL prio 1
# ^^^ Some servers inside the intranet
$TCPRG class add dev $SIF parent 1:11 classid 1:112 htb rate 250kbit ceil $LINKCEIL prio 1
# ^^^ Rest rest of the intranet traffic


$TCPRG filter add dev $SIF protocol ip parent 1:0 prio 1 u32 match ip $DIRECTION 10.100.0.0/16 flowid 1:10
$TCPRG filter add dev $SIF protocol ip parent 1:0 prio 2 u32 match ip $DIRECTION 10.0.0.1 flowid 1:10
# ^^^ DNS Cache and Management Server traffic


$TCPRG filter add dev $SIF protocol ip parent 1:0 prio 1 u32 match ip dport 22 0xffff     match ip $DIRECTION 10.0.0.0/8 flowid 1:110
# ^^^ SSH-Traffic.
$TCPRG filter add dev $SIF protocol ip parent 1:0 prio 3 u32 match ip $OTHERDIRECTION 141.70.120.19 match ip $DIRECTION 10.0.0.0/8 flowid 1:111
# ^^^ SIP VOIP Server
$TCPRG filter add dev $SIF protocol ip parent 1:0 prio 4 u32                            match ip $DIRECTION 10.0.0.0/8 flowid 1:112
# ^^^ the rest of the internal traffic

